config/routes.rb
      get "/view_state/repository/:id.:format" => "repository_view_state#show", :as => :repository_view_state
      get "/view_state/project/:id.:format" => "project_view_state#show", :as => :project_view_state
      get "/view_state.:format" => "user_view_state#show", :as => :view_state

      # Used to be we supported things like /users/~zmalltalker/mainline
      # No more, ~<user_name> is the canonical user URL namespace
      get "/*slug" => (redirect do |params, request|
                         request.fullpath.sub("users/", "~")
                       end), :slug => /.*/
    end
  end

  # `resources :users` can't do the ~<user> ids
  get "/~:id.keys" => "public_keys#index", :id => /[^\/]+/
  get "/~:id(.:format)" => "users#show", :as => "user", :id => /[^\/]+/
  get "/~:id/edit(.:format)" => "users#edit", :as => "edit_user", :id => /[^\/]+/
  put "/~:id(.:format)" => "users#update", :id => /[^\/]+/
  delete "/~:id(.:format)" => "users#destroy", :id => /[^\/]+/

  # Additional user actions
  scope "/~:id", :id => /[^\/]+/, :as => :user do
    get "/delete_current" => "users#destroy", :as => :delete_current
    delete "/avatar" => "avatars#destroy"
    get "/watchlist" => "user_watchlists#show", :as => :watchlist
    get "/feed" => "user_feeds#show", :as => :feed
    put "/update_password" => "passwords#update", :as => :update_password

    get "/aliases" => "users#edit", :defaults => { :tab => "email-aliases" }, :as => :edit_email_aliases
    get "/ssh-keys" => "users#edit", :defaults => { :tab => "ssh-keys" }, :as => :edit_ssh_keys
    get "/password" => "users#edit", :defaults => { :tab => "change-password" }, :as => :edit_password
    get "/favorites" => "users#edit", :defaults => { :tab => "manage-favorites" }, :as => :edit_favorites
  end

  # Nested user resources. This is in a separate scope because the
  # controllers expect params[:user_id] to contain the user, not
  # params[:id] as in the scope above
  scope "/~:user_id", :user_id => /[^\/]+/, :as => :user do
    resources :keys, :only => [:new, :create, :destroy, :index]

    resources :aliases do
      member do
        get :confirm
      end
    end

    get "/repositories" => "repositories#index"
    resource :license, :only => [:show, :edit, :update]
    match "/*slug" => "owner_redirections#show"
  end

  ### R3. Sessions
  resource :sessions
  get "/sessions" => "sessions#create", :as => :open_id_complete
  get "/login" => "sessions#new", :as => :login
  get "/login/http" => "sessions#http" # for Kerberos authentication
  get "/logout" => "sessions#destroy", :as => :logout

  ### R4. Groups
  resources :groups, :only => [:index, :new, :create]
  # `resource :groups` can't do the +<group> ids
  get "/+:id(.:format)" => "groups#show", :as => "group", :id => /[^\/]+/
  get "/+:id/edit(.:format)" => "groups#edit", :as => "edit_group", :id => /[^\/]+/
  put "/+:id(.:format)" => "groups#update", :id => /[^\/]+/
  delete "/+:id(.:format)" => "groups#destroy", :id => /[^\/]+/

  # Additional group actions
  scope "/+:id", :id => /[^\/]+/, :as => :group do
    delete "avatar" => "groups#avatar"
  end

  # Nested group resources. This is in a separate scope because the
  # controllers expect params[:group_id] to contain the group, not
  # params[:id] as in the scope above
  scope "/+:group_id", :id => /[^\/]+/, :as => :group do
    resources :memberships
    get "/repositories" => "repositories#index"
    match "/*slug" => "owner_redirections#show"
  end

  ### R5. Site-wide wiki
  get "/wiki/:site_id/config" => "site_wiki_pages#repository_config", :as => :site_wiki_git_access_connect
  get "/wiki/:site_id/writable_by" => "site_wiki_pages#writable_by", :as => :site_wiki_git_writable_by

  resources :site_wiki_pages, :path => "/wiki" do
    collection do
      get :git_access
    end

    member do
      get :history
    end
  end

  ### R6. Direct merge request access
  match "/merge_request_landing_page" => "merge_requests#oauth_return", :as => :merge_request_landing_page
  get "/merge_requests/:id" => "merge_requests#direct_access", :as => :merge_request_direct_access

  ### R7. Site controller, various loose pages
  get "/activities" => "site#public_timeline", :as => :activity
  get "/dashboard" => "site#dashboard", :as => :dashboard
  get "/my-activities" => "site#my_activities", :as => :dashboard_my_activities
  get "/about" => "site#about", :as => :about
  get "/about/:action" => "site#index", :as => :about_page
  get "/contact" => "site#contact", :as => :contact

  ### R8. Administration
  namespace :admin do
    get "/" => redirect { |params, request| "/admin/repositories" }

    resources :users, :only => [:index, :new, :create] do
      member do
        put :suspend
        put :flip_admin_status
        put :unsuspend
        put :reset_password
      end

      resources :keys, only: [:index, :new, :create, :destroy]
    end

    resources :projects, :only => [:show] do
      resource :oauth_settings, :only => [:show, :edit, :update]
    end

    resources :repositories, :only => [:index] do
      member do
        put :recreate
      end
    end

    resources :project_proposals, :only => [:index, :new, :create]
    post "/project_proposals/:id/reject" => "project_proposals#reject"
    post "/project_proposals/:id/approve" => "project_proposals#approve"
  end

  ### R9. API
  namespace :api do
    get ":project_id/:repository_id/log/graph(.:format)" => "graphs#show"
    get ":project_id/:repository_id/log/graph/*branch(.:format)" => "graphs#show"

    namespace :internal do
      get "/repo-config", to: "repository_configurations#show"
      get "/authenticate", to: "users#authenticate"
      get "/hooks/pre-receive", to: "hooks#pre_receive"
      post "/hooks/post-receive", to: "hooks#post_receive"
    end
  end

  ### R10. Events
  resources :events do
    member do
      get :commits
    end
  end

  ### R11. Additional logged in user resources
  resources :messages do
    collection do
      get :sent
      put :bulk_update
      get :all
      get :auto_complete_for_message_recipients
    end

    member do
      post :reply
      put :read
    end
  end

  resources :favorites, :only => [:index, :create, :update, :destroy]

  ### R12. Search
  get "/search", :controller => "searches", :action => "show", :as => :search

  ### R13. Auto-completion
  resources :user_auto_completions, :only => [:index]
  resources :group_auto_completions, :only => [:index]

  ### R14. Projects
  resources :projects, :only => [:index, :create]
  get "/:id/edit(.:format)" => "projects#edit"

  resources :projects, :path => "/" do
    member do
      put :preview
      get :edit_slug
      put :edit_slug
      get :confirm_delete
      get "/ownership/edit" => "project_ownerships#edit", :as => :transfer_ownership
      put "/ownership/edit" => "project_ownerships#update", :as => :transfer_ownership
    end

    resources :project_memberships, :only => [:index, :new, :create, :destroy]
    get "/community", :controller => :project_community, :action => :index
    get "/merge_requests", :controller => :project_merge_requests, :action => :index

    resources :pages do
      collection do
        get :git_access
      end

      member do
        get :history
      end
    end

    ### R14.2. Repositories

    # Listing repositories and creating new ones happens over
    # /<project>/repositories/, e.g:
    #   /gitorious/repositories/new
    resources :repositories, :only => [:index, :new, :create]

    # Browsing, editing and destroying existing repositories happens over
    # /<project>/<repository_name>/, e.g.:
    #   /gitorious/mainline
    #   /gitorious/mainline/edit
    resources(:repositories, {
                :path => "/",
                :only => [:show, :edit, :update, :destroy]
              }) do
      member do
        post "/create_clone" => "repository_clones#create"
        get "/clone" => "repository_clones#new"
        get "/search_clones" => "repository_clone_searches#show"
        get :committers
        get :confirm_delete
        get "/ownership/edit" => "repository_ownerships#edit", :as => :transfer_ownership
        put "/ownership/edit" => "repository_ownerships#update"
        get "/activities" => "repository_activities#index", :as => :activities
      end

      resources :comments, :controller => :repository_comments, :only => [:index]

      resources :services, :only => [:index, :destroy] do
        collection do
          post "/:service_type" => "services#create", :as => :create
          get "/:service_type" => "services#index"
        end
        resources :service_tests, :as => :tests, :only => [:create]
      end

      match "/community", :controller => :repository_community, :action => :index

      resources :merge_requests do
        collection do
          post :create
          post :commit_list
          post :target_branches
        end

        member do
          get :commit_status
          get :version
          get :terms_accepted
        end

        resources :comments, :controller => :merge_request_comments, :only => [:index, :create, :update]

        get "/diffs(/:version)" => "merge_request_versions#show", :as => :version
        get "/diffs/:version/comments/:commit_range(.:format)" => "merge_request_version_comments#index", :as => :version_comments
        post "/diffs/:version/comments/:commit_range" => "merge_request_version_comments#create", :as => :version_create_comment
        put "/diffs/:version/comments/:id" => "merge_request_version_comments#update", :as => :version_update_comment
        get "/diffs/:version/comments/:id/edit" => "merge_request_version_comments#edit", :as => :version_edit_comment
      end

      resources :repository_memberships, :only => [:new, :create, :destroy]
      resources :committerships, :only => [:index, :create, :edit, :update, :destroy]

      match "/commits/*id/feed(.:format)" => "commits#feed", :as => :formatted_commits_feed

app/models/membership.rb
# encoding: utf-8
#--
#   Copyright (C) 2013 Gitorious AS
#   Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies)
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU Affero General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU Affero General Public License for more details.
#
#   You should have received a copy of the GNU Affero General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
#++

class Membership < ActiveRecord::Base
  belongs_to :group
  belongs_to :user
  belongs_to :role
  has_many :messages, :as => :notifiable
  before_destroy :nullify_messages
  attr_accessor :inviter

  def title
    "Member"
  end

  def login
    user.login if user
  end

  def uniq?
    membership = Membership.where(:user_id => user_id, :group_id => group_id).first
    membership.nil? || membership == self
  end

  protected

  def nullify_messages
    messages.update_all({:notifiable_id => nil, :notifiable_type => nil})
  end
end

app/controllers/memberships_controller.rb
# encoding: utf-8
#--
#   Copyright (C) 2012-2014 Gitorious AS
#   Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies)
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU Affero General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU Affero General Public License for more details.
#
#   You should have received a copy of the GNU Affero General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
#++

class MembershipsController < ApplicationController
  before_filter :find_group
  before_filter :find_membership, :only => [:edit, :update, :destroy]
  before_filter :ensure_group_adminship, :except => [:index, :show, :create]
  renders_in_global_context

  def index
    memberships = paginate(page_free_redirect_options) do
      @group.memberships.paginate(:page => params[:page])
    end

    return if memberships.length == 0 && params.key?(:page)

    render("index", :locals => {
        :memberships => memberships,
        :group => @group,
        :total_pages => memberships.respond_to?(:total_pages) ? memberships.total_pages : 1,
        :page => memberships.respond_to?(:current_page) ? memberships.current_page : 1
      })
  end

  def show
    redirect_to(group_memberships_path(@group))
  end

  def new
    render_form(@group.memberships.new)
  end

  def create
    input = { :login => params[:membership][:login], :role => params[:membership][:role_id] }
    outcome = CreateMembership.new(self, @group, current_user).execute(input)

    pre_condition_failed(outcome) do |f|
      f.when(:admin_required) { |c| access_denied }
    end

    outcome.success do |result|
      flash[:success] = I18n.t("memberships_controller.membership_created")
      redirect_to group_memberships_path(@group)
    end

    outcome.failure do |membership|
      render_form(membership)
    end
  end

  def edit
    render_edit_form
  end

  def update
    outcome = UpdateMembership.new(@membership).execute(params[:membership])

    outcome.success do
      flash[:success] = I18n.t("memberships_controller.membership_updated")
      redirect_to group_memberships_path(@group)
    end

    outcome.failure do |membership|
      render_edit_form(membership)
    end
  end

  def destroy
    outcome = DestroyMembership.new(@membership).execute

    outcome.success do
      flash[:success] = I18n.t("memberships_controller.membership_destroyed")
    end

    outcome.pre_condition_failed do
      flash[:error] = I18n.t("memberships_controller.failed_to_destroy")
    end

    redirect_to group_memberships_path(@group)
  end

  protected

  def find_group
    @group = Team.find_by_name!(params[:group_id])
  end

  def find_membership
    @membership = @group.memberships.find(params[:id])
  end

  def ensure_group_adminship
    unless admin?(current_user, @group)
      access_denied and return
    end
  end

  def render_edit_form(membership = @membership)
    render("edit", :locals => { :membership => membership, :group => @group })
  end

  def render_form(membership)
    render(:action => "new", :locals => {
        :membership => membership,
        :group => @group,
        :login => params[:user] && params[:user][:login]
      })
  end
end

app/views/memberships/edit.html.erb
<%
  #--
  #   Copyright (C) 2012-2013 Gitorious AS
  #   Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies)
  #
  #   This program is free software: you can redistribute it and/or modify
  #   it under the terms of the GNU Affero General Public License as published by
  #   the Free Software Foundation, either version 3 of the License, or
  #   (at your option) any later version.
  #
  #   This program is distributed in the hope that it will be useful,
  #   but WITHOUT ANY WARRANTY; without even the implied warranty of
  #   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  #   GNU Affero General Public License for more details.
  #
  #   You should have received a copy of the GNU Affero General Public License
  #   along with this program.  If not, see <http://www.gnu.org/licenses/>.
  #++
%>

<% @title = "#{group.name} members" %>

<%= render('groups/header', :active => true, :title => group.name, :group => group) %>

<div class="container gts-container">
  <%= simple_form_for [group, membership],
    :url => group_membership_path(group, membership.id),
    :method => membership.persisted? ? 'put' : 'post',
    :html => { :class => "form-horizontal" } do |f| %>
    <fieldset>
      <legend>Editing <%= membership.user.fullname %>'s role</legend>
      <%= f.input :role_id, :collection => Role.all.map { |r| [r.name, r.id] }, :include_blank => false %>
    </fieldset>
    <div class="form-actions">
      <button class="btn btn-primary" type="submit">Update</button>
    </div>
  <% end %>
</div>

app/views/memberships/index.html.erb
<%
  #--
  #   Copyright (C) 2012-2013 Gitorious AS
  #   Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies)
  #
  #   This program is free software: you can redistribute it and/or modify
  #   it under the terms of the GNU Affero General Public License as published by
  #   the Free Software Foundation, either version 3 of the License, or
  #   (at your option) any later version.
  #
  #   This program is distributed in the hope that it will be useful,
  #   but WITHOUT ANY WARRANTY; without even the implied warranty of
  #   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  #   GNU Affero General Public License for more details.
  #
  #   You should have received a copy of the GNU Affero General Public License
  #   along with this program.  If not, see <http://www.gnu.org/licenses/>.
  #++
%>

<%= render("groups/header", :active => true, :title => group.name, :group => group) %>

<% @title = "#{group.name} members" %>

<div class="container gts-container">
  <% if admin?(current_user, @group) and @group.is_a?(Group) %>
    <a href="<%= new_group_membership_path(group) %>" class="btn btn-primary pull-right">
      <i class="icon-plus-sign icon-white"></i>
      <%= t("views.memberships.add_new_member") %>
    </a>
  <% end %>
  <h2 class="gts-legend">Members</h2>
  <table class="table table-striped">
    <thead>
      <th><%= t(:created_at, :scope => "activerecord.attributes.memberships").humanize %></th>
      <th><%= t(:login, :scope => "activerecord.attributes.user").humanize %></th>
      <th><%= t(:email, :scope => "activerecord.attributes.user").humanize %></th>
      <th><%= t(:name, :scope => "activerecord.attributes.roles").humanize %></th>
      <th></th>
    </thead>
    <tbody class="gts-tbody-actions">
      <% memberships.each do |membership| %>
        <tr>
          <td><%= l(membership.created_at, :format => :short) %></td>
          <td><%= link_to h(membership.user.login), membership.user %></td>
          <td><%= membership.user.public_email? ? h(membership.user.email) : "N/A" %></td>
          <td><%=h membership.role.name %></td>
          <td>
            <%- if admin?(current_user, group) && group.is_a?(Group) %>
              <%= link_to(t("views.common.edit"), edit_group_membership_path(group, membership), :class => "btn") %>
              <%= link_to("Remove", group_membership_path(group, membership), :class => "btn btn-danger", :method => :delete) %>
            <%- end %>
          </td>
        </tr>
      <% end %>
    </tbody>
  </table>
  <%= raw JustPaginate.page_navigation(page, total_pages) { |n| group_memberships_path(:page => n) } %>
</div>

app/views/memberships/new.html.erb
<%
  #--
  #   Copyright (C) 2012-2013 Gitorious AS
  #   Copyright (C) 2009 Johan Sørensen <johan@johansorensen.com>
  #   Copyright (C) 2009 Tor Arne Vestbø <torarnv@gmail.com>
  #
  #   This program is free software: you can redistribute it and/or modify
  #   it under the terms of the GNU Affero General Public License as published by
  #   the Free Software Foundation, either version 3 of the License, or
  #   (at your option) any later version.
  #
  #   This program is distributed in the hope that it will be useful,
  #   but WITHOUT ANY WARRANTY; without even the implied warranty of
  #   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  #   GNU Affero General Public License for more details.
  #
  #   You should have received a copy of the GNU Affero General Public License
  #   along with this program.  If not, see <http://www.gnu.org/licenses/>.
  #++
%>

<% @title = "Add member to #{group.name}" %>

<%= render('groups/header', :active => true, :title => group.name, :group => group) %>

<div class="container">
  <%= simple_form_for(membership, :url => group_memberships_path(group), :html => { :class => "form-horizontal" }) do |f| %>
    <fieldset>
      <legend><%= @title %></legend>
      <%= f.input :login, :label => t("views.users.username") %>
      <%= f.input :role_id, :collection => Role.all.map { |r| [r.name, r.id] }, :include_blank => false %>
    </fieldset>
    <div class="form-actions">
      <%= f.submit 'Save', :class => 'btn btn-primary' %>
    </div>
  <% end %>
</div>